Using Rhinocommon, how do I generate a surface from these curves?

I’ve been working with NetworkSurface a lot lately, especially with c#. However, I can’t seem to generate a surface from these curves (file included here: sin(theta .5).3dm (114.1 KB)
), and I’ve tried these settings (if the first fails, I move on to the next):

Rhino.Geometry.NurbsSurface.CreateNetworkSurface(uCurves, 1, 1, vCurves, 1, 1, 0.00001, 0.00001, .001, out error) - full u and v curves

Rhino.Geometry.NurbsSurface.CreateNetworkSurface(uCurves, 1, 1, vCurves, 1, 1, 0.0001, 0.0001, .001, out error) - full u and v curves

Rhino.Geometry.NurbsSurface.CreateNetworkSurface(uCurves, 1, 1, vCurves, 1, 1, 0.001, 0.001, .01, out error) - full u and end capped v curves

Rhino.Geometry.NurbsSurface.CreateNetworkSurface(uCurves, 1, 1, vCurves, 1, 1, 0.01, 0.01, .01, out error) - full uv and end capped u curves

Rhino.Geometry.NurbsSurface.CreateNetworkSurface(uCurves, 1, 1, vCurves, 1, 1, 0.001, 0.001, 1, out error) - full u and end capped v curves

Rhino.Geometry.NurbsSurface.CreateNetworkSurface(uCurves, 1, 1, vCurves, 1, 1, 0.01, 0.01, 1, out error) - full v and end capped v curves

I grouped the u curves and v curves in the file. What can I change or do better? Do I need all these methods to safely generate a surface? Much appreciated. sin(theta .5).3dm (114.1 KB)

Select only one set of curves (the curvy ones, not the more circular ones), then use Loft
It gives a good surface. I did it interactively, now you need to program it :slight_smile:

I can get this working fine, but my issue is that I need the brep to be saved as a Surface, and my efforts proved fruitless in my endeavors to find a conversion.

I created a method that makes the curves, then it calls the six lines shown in my question to make the surface. It returns a list of Surfaces, in case more than one is made. I suppose I can make a list of objects so I can put in both breps and surfaces, but then I wouldn’t know which loft will provide the non-curvy brep.